## mingw-w64-oatpp-1.3.1-1.src.tar.zst

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1 FATAL_ERROR)

file(STRINGS "${CMAKE_CURRENT_LIST_DIR}/src/oatpp/core/base/Environment.hpp" OATPP_VERSION_MACRO REGEX "#define OATPP_VERSION \"[0-9]+.[0-9]+.[0-9]+\"$")
string(REGEX REPLACE "#define OATPP_VERSION \"([0-9]+.[0-9]+.[0-9]+)\"$" "\\1" oatpp_VERSION "${OATPP_VERSION_MACRO}")

###################################################################################################
## These variables are passed to oatpp-module-install.cmake script
## use these variables to configure module installation

set(OATPP_THIS_MODULE_NAME oatpp) ## name of the module (also name of folders in installation dirs)
set(OATPP_THIS_MODULE_VERSION ${oatpp_VERSION}) ## version of the module (also sufix of folders in installation dirs)

###################################################################################################

project(oatpp VERSION ${OATPP_THIS_MODULE_VERSION} LANGUAGES CXX)

option(BUILD_SHARED_LIBS "Build shared libraries" OFF)
option(OATPP_INSTALL "Create installation target for oat++" ON)
option(OATPP_BUILD_TESTS "Create test target for oat++" ON)
option(OATPP_LINK_TEST_LIBRARY "Link oat++ test library" ON)
option(OATPP_LINK_ATOMIC "Link atomic library for other platform than MSVC|MINGW|APPLE|FreeBSD" ON)
option(OATPP_MSVC_LINK_STATIC_RUNTIME "MSVC: Link with static runtime (/MT and /MTd)." OFF)

###################################################################################################
## COMPILATION CONFIG #############################################################################
###################################################################################################

if(OATPP_LINK_TEST_LIBRARY)
	set(OATPP_THIS_MODULE_LIBRARIES oatpp oatpp-test) ## list of libraries to find when find_package is called
	set(OATPP_THIS_MODULE_TARGETS oatpp oatpp-test) ## list of targets to install
	set(OATPP_THIS_MODULE_DIRECTORIES oatpp oatpp-test) ## list of directories to install
else()
	set(OATPP_THIS_MODULE_LIBRARIES oatpp) ## list of libraries to find when find_package is called
	set(OATPP_THIS_MODULE_TARGETS oatpp) ## list of targets to install
	set(OATPP_THIS_MODULE_DIRECTORIES oatpp) ## list of directories to install
endif()

option(OATPP_DISABLE_ENV_OBJECT_COUNTERS "Disable object counting for Release builds for better performance" OFF)
option(OATPP_DISABLE_POOL_ALLOCATIONS "This will make oatpp::base::memory::MemoryPool, method obtain and free call new and delete directly" OFF)

set(OATPP_THREAD_HARDWARE_CONCURRENCY "AUTO" CACHE STRING "Predefined value for function oatpp::concurrency::Thread::getHardwareConcurrency()")

option(OATPP_COMPAT_BUILD_NO_THREAD_LOCAL "Disable 'thread_local' feature" OFF)
option(OATPP_COMPAT_BUILD_NO_SET_AFFINITY "No 'pthread_setaffinity_np' method" OFF)

option(OATPP_DISABLE_LOGV "DISABLE logs priority V" OFF)
option(OATPP_DISABLE_LOGD "DISABLE logs priority D" OFF)
option(OATPP_DISABLE_LOGI "DISABLE logs priority I" OFF)
option(OATPP_DISABLE_LOGW "DISABLE logs priority W" OFF)
option(OATPP_DISABLE_LOGE "DISABLE logs priority E" OFF)

## Print config ##################################################################################

message("\n############################################################################")
message("## oatpp module compilation config:\n")

message("OATPP_DISABLE_ENV_OBJECT_COUNTERS=${OATPP_DISABLE_ENV_OBJECT_COUNTERS}")
message("OATPP_THREAD_HARDWARE_CONCURRENCY=${OATPP_THREAD_HARDWARE_CONCURRENCY}")
message("OATPP_COMPAT_BUILD_NO_THREAD_LOCAL=${OATPP_COMPAT_BUILD_NO_THREAD_LOCAL}")

## Set definitions ###############################################################################

if(OATPP_DISABLE_ENV_OBJECT_COUNTERS)
    add_definitions(-DOATPP_DISABLE_ENV_OBJECT_COUNTERS)
endif()

if(OATPP_DISABLE_POOL_ALLOCATIONS)
    add_definitions (-DOATPP_DISABLE_POOL_ALLOCATIONS)
    message("WARNING: OATPP_DISABLE_POOL_ALLOCATIONS option is deprecated and has no effect.")
endif()

set(AUTO_VALUE AUTO)
if(NOT OATPP_THREAD_HARDWARE_CONCURRENCY STREQUAL AUTO_VALUE)
    add_definitions (-DOATPP_THREAD_HARDWARE_CONCURRENCY=${OATPP_THREAD_HARDWARE_CONCURRENCY})
endif()

if(OATPP_THREAD_DISTRIBUTED_MEM_POOL_SHARDS_COUNT)
    add_definitions (-DOATPP_THREAD_DISTRIBUTED_MEM_POOL_SHARDS_COUNT=${OATPP_THREAD_DISTRIBUTED_MEM_POOL_SHARDS_COUNT})
    message("WARNING: OATPP_THREAD_DISTRIBUTED_MEM_POOL_SHARDS_COUNT option is deprecated and has no effect.")
endif()

if(OATPP_COMPAT_BUILD_NO_THREAD_LOCAL)
    add_definitions(-DOATPP_COMPAT_BUILD_NO_THREAD_LOCAL)
endif()

if(OATPP_COMPAT_BUILD_NO_SET_AFFINITY)
    add_definitions(-DOATPP_COMPAT_BUILD_NO_SET_AFFINITY)
endif()

if(OATPP_DISABLE_LOGV)
    add_definitions(-DOATPP_DISABLE_LOGV)
endif()

if(OATPP_DISABLE_LOGD)
    add_definitions(-DOATPP_DISABLE_LOGD)
endif()

if(OATPP_DISABLE_LOGI)
    add_definitions(-DOATPP_DISABLE_LOGI)
endif()

if(OATPP_DISABLE_LOGW)
    add_definitions(-DOATPP_DISABLE_LOGW)
endif()

if(OATPP_DISABLE_LOGE)
    add_definitions(-DOATPP_DISABLE_LOGE)
endif()

if(CMAKE_COMPILER_IS_GNUCXX AND ${CMAKE_CXX_COMPILER_VERSION} VERSION_LESS 5.0)
    add_definitions(-DOATPP_DISABLE_STD_PUT_TIME)
endif()

message("\n############################################################################\n")

###################################################################################################

message("oatpp version: '${OATPP_THIS_MODULE_VERSION}'")

include(cmake/compiler-flags.cmake)

include(cmake/msvc-runtime.cmake)
configure_msvc_runtime()

include(cmake/project.cmake)

add_subdirectory(src)

if(OATPP_BUILD_TESTS)
    enable_testing()
    add_subdirectory(test)
endif()


include(cpack.cmake)

# This must always be last!
include( CPack )

=== src/CMakeLists.txt ===

#######################################################################################################
## oatpp

add_library(oatpp
        oatpp/algorithm/CRC.cpp
        oatpp/algorithm/CRC.hpp
        oatpp/codegen/ApiClient_define.hpp
        oatpp/codegen/ApiClient_undef.hpp
        oatpp/codegen/ApiController_define.hpp
        oatpp/codegen/ApiController_undef.hpp
        oatpp/codegen/DbClient_define.hpp
        oatpp/codegen/DbClient_undef.hpp
        oatpp/codegen/DTO_define.hpp
        oatpp/codegen/DTO_undef.hpp
        oatpp/codegen/api_controller/auth_define.hpp
        oatpp/codegen/api_controller/auth_undef.hpp
        oatpp/codegen/api_controller/base_define.hpp
        oatpp/codegen/api_controller/base_undef.hpp
        oatpp/codegen/api_controller/bundle_define.hpp
        oatpp/codegen/api_controller/bundle_undef.hpp
        oatpp/codegen/api_controller/cors_define.hpp
        oatpp/codegen/api_controller/cors_undef.hpp
        oatpp/codegen/dto/base_define.hpp
        oatpp/codegen/dto/base_undef.hpp
        oatpp/codegen/dto/enum_define.hpp
        oatpp/codegen/dto/enum_undef.hpp
        oatpp/core/IODefinitions.cpp
        oatpp/core/IODefinitions.hpp
        oatpp/core/Types.hpp
        oatpp/core/async/ConditionVariable.cpp
        oatpp/core/async/ConditionVariable.hpp
        oatpp/core/async/Coroutine.cpp
        oatpp/core/async/Coroutine.hpp
        oatpp/core/async/CoroutineWaitList.cpp
        oatpp/core/async/CoroutineWaitList.hpp
        oatpp/core/async/Error.cpp
        oatpp/core/async/Error.hpp
        oatpp/core/async/Executor.cpp
        oatpp/core/async/Executor.hpp
        oatpp/core/async/Lock.cpp
        oatpp/core/async/Lock.hpp
        oatpp/core/async/Processor.cpp
        oatpp/core/async/Processor.hpp
        oatpp/core/async/utils/FastQueue.hpp
        oatpp/core/async/worker/IOEventWorker_common.cpp
        oatpp/core/async/worker/IOEventWorker_epoll.cpp
        oatpp/core/async/worker/IOEventWorker_kqueue.cpp
        oatpp/core/async/worker/IOEventWorker_stub.cpp
        oatpp/core/async/worker/IOEventWorker.hpp
        oatpp/core/async/worker/IOWorker.cpp
        oatpp/core/async/worker/IOWorker.hpp
        oatpp/core/async/worker/TimerWorker.cpp
        oatpp/core/async/worker/TimerWorker.hpp
        oatpp/core/async/worker/Worker.cpp
        oatpp/core/async/worker/Worker.hpp
        oatpp/core/base/CommandLineArguments.cpp
        oatpp/core/base/CommandLineArguments.hpp
        oatpp/core/base/Config.hpp
        oatpp/core/base/Countable.cpp
        oatpp/core/base/Countable.hpp
        oatpp/core/base/Environment.cpp
        oatpp/core/base/Environment.hpp
        oatpp/core/base/ObjectHandle.hpp
        oatpp/core/concurrency/SpinLock.cpp
        oatpp/core/concurrency/SpinLock.hpp
        oatpp/core/concurrency/Thread.cpp
        oatpp/core/concurrency/Thread.hpp
        oatpp/core/data/Bundle.cpp
        oatpp/core/data/Bundle.hpp
        oatpp/core/data/buffer/FIFOBuffer.cpp
        oatpp/core/data/buffer/FIFOBuffer.hpp
        oatpp/core/data/buffer/IOBuffer.cpp
        oatpp/core/data/buffer/IOBuffer.hpp
        oatpp/core/data/buffer/Processor.cpp
        oatpp/core/data/buffer/Processor.hpp
        oatpp/core/data/mapping/ObjectMapper.cpp
        oatpp/core/data/mapping/ObjectMapper.hpp
        oatpp/core/data/mapping/TypeResolver.cpp
        oatpp/core/data/mapping/TypeResolver.hpp
        oatpp/core/data/mapping/type/Any.cpp
        oatpp/core/data/mapping/type/Any.hpp
        oatpp/core/data/mapping/type/Collection.hpp
        oatpp/core/data/mapping/type/Enum.cpp
        oatpp/core/data/mapping/type/Enum.hpp
        oatpp/core/data/mapping/type/List.cpp
        oatpp/core/data/mapping/type/List.hpp
        oatpp/core/data/mapping/type/Map.hpp
        oatpp/core/data/mapping/type/Object.cpp
        oatpp/core/data/mapping/type/Object.hpp
        oatpp/core/data/mapping/type/PairList.cpp
        oatpp/core/data/mapping/type/PairList.hpp
        oatpp/core/data/mapping/type/Primitive.cpp
        oatpp/core/data/mapping/type/Primitive.hpp
        oatpp/core/data/mapping/type/Type.cpp
        oatpp/core/data/mapping/type/Type.hpp
        oatpp/core/data/mapping/type/UnorderedMap.cpp
        oatpp/core/data/mapping/type/UnorderedMap.hpp
        oatpp/core/data/mapping/type/UnorderedSet.cpp
        oatpp/core/data/mapping/type/UnorderedSet.hpp
        oatpp/core/data/mapping/type/Vector.cpp
        oatpp/core/data/mapping/type/Vector.hpp
        oatpp/core/data/resource/File.cpp
        oatpp/core/data/resource/File.hpp
        oatpp/core/data/resource/InMemoryData.cpp
        oatpp/core/data/resource/InMemoryData.hpp
        oatpp/core/data/resource/Resource.hpp
        oatpp/core/data/resource/TemporaryFile.cpp
        oatpp/core/data/resource/TemporaryFile.hpp
        oatpp/core/data/share/LazyStringMap.hpp
        oatpp/core/data/share/MemoryLabel.cpp
        oatpp/core/data/share/MemoryLabel.hpp
        oatpp/core/data/share/StringTemplate.cpp
        oatpp/core/data/share/StringTemplate.hpp
        oatpp/core/data/stream/BufferStream.cpp
        oatpp/core/data/stream/BufferStream.hpp
        oatpp/core/data/stream/FIFOStream.cpp
        oatpp/core/data/stream/FIFOStream.hpp
        oatpp/core/data/stream/FileStream.cpp
        oatpp/core/data/stream/FileStream.hpp
        oatpp/core/data/stream/Stream.cpp
        oatpp/core/data/stream/Stream.hpp
        oatpp/core/data/stream/StreamBufferedProxy.cpp
        oatpp/core/data/stream/StreamBufferedProxy.hpp
        oatpp/core/macro/basic.hpp
        oatpp/core/macro/codegen.hpp
        oatpp/core/macro/component.hpp
        oatpp/core/parser/Caret.cpp
        oatpp/core/parser/Caret.hpp
        oatpp/core/parser/ParsingError.cpp
        oatpp/core/parser/ParsingError.hpp
        oatpp/core/provider/Invalidator.hpp
        oatpp/core/provider/Pool.hpp
        oatpp/core/provider/Provider.hpp
        oatpp/core/utils/Binary.cpp
        oatpp/core/utils/Binary.hpp
        oatpp/core/utils/ConversionUtils.cpp
        oatpp/core/utils/ConversionUtils.hpp
        oatpp/core/utils/Random.cpp
        oatpp/core/utils/Random.hpp
        oatpp/core/utils/String.cpp
        oatpp/core/utils/String.hpp
        oatpp/encoding/Base64.cpp
        oatpp/encoding/Base64.hpp
        oatpp/encoding/Hex.cpp
        oatpp/encoding/Hex.hpp
        oatpp/encoding/Unicode.cpp
        oatpp/encoding/Unicode.hpp
        oatpp/encoding/Url.cpp
        oatpp/encoding/Url.hpp
        oatpp/network/Address.cpp
        oatpp/network/Address.hpp
        oatpp/network/ConnectionHandler.hpp
        oatpp/network/ConnectionPool.cpp
        oatpp/network/ConnectionPool.hpp
        oatpp/network/ConnectionProvider.cpp
        oatpp/network/ConnectionProvider.hpp
        oatpp/network/ConnectionProviderSwitch.cpp
        oatpp/network/ConnectionProviderSwitch.hpp
        oatpp/network/Server.cpp
        oatpp/network/Server.hpp
        oatpp/network/Url.cpp
        oatpp/network/Url.hpp
        oatpp/network/monitor/ConnectionInactivityChecker.cpp
        oatpp/network/monitor/ConnectionInactivityChecker.hpp
        oatpp/network/monitor/ConnectionMaxAgeChecker.cpp
        oatpp/network/monitor/ConnectionMaxAgeChecker.hpp
        oatpp/network/monitor/ConnectionMonitor.cpp
        oatpp/network/monitor/ConnectionMonitor.hpp
        oatpp/network/monitor/MetricsChecker.hpp
        oatpp/network/monitor/StatCollector.hpp
        oatpp/network/tcp/Connection.cpp
        oatpp/network/tcp/Connection.hpp
        oatpp/network/tcp/ConnectionConfigurer.hpp
        oatpp/network/tcp/client/ConnectionProvider.cpp
        oatpp/network/tcp/client/ConnectionProvider.hpp
        oatpp/network/tcp/server/ConnectionProvider.cpp
        oatpp/network/tcp/server/ConnectionProvider.hpp
        oatpp/network/virtual_/Interface.cpp
        oatpp/network/virtual_/Interface.hpp
        oatpp/network/virtual_/Pipe.cpp
        oatpp/network/virtual_/Pipe.hpp
        oatpp/network/virtual_/Socket.cpp
        oatpp/network/virtual_/Socket.hpp
        oatpp/network/virtual_/client/ConnectionProvider.cpp
        oatpp/network/virtual_/client/ConnectionProvider.hpp
        oatpp/network/virtual_/server/ConnectionProvider.cpp
        oatpp/network/virtual_/server/ConnectionProvider.hpp
        oatpp/orm/Connection.hpp
        oatpp/orm/DbClient.cpp
        oatpp/orm/DbClient.hpp
        oatpp/orm/Executor.cpp
        oatpp/orm/Executor.hpp
        oatpp/orm/QueryResult.cpp
        oatpp/orm/QueryResult.hpp
        oatpp/orm/SchemaMigration.cpp
        oatpp/orm/SchemaMigration.hpp
        oatpp/orm/Transaction.cpp
        oatpp/orm/Transaction.hpp
        oatpp/parser/json/Beautifier.cpp
        oatpp/parser/json/Beautifier.hpp
        oatpp/parser/json/Utils.cpp
        oatpp/parser/json/Utils.hpp
        oatpp/parser/json/mapping/Deserializer.cpp
        oatpp/parser/json/mapping/Deserializer.hpp
        oatpp/parser/json/mapping/ObjectMapper.cpp
        oatpp/parser/json/mapping/ObjectMapper.hpp
        oatpp/parser/json/mapping/Serializer.cpp
        oatpp/parser/json/mapping/Serializer.hpp
        oatpp/web/client/ApiClient.cpp
        oatpp/web/client/ApiClient.hpp
        oatpp/web/client/HttpRequestExecutor.cpp
        oatpp/web/client/HttpRequestExecutor.hpp
        oatpp/web/client/RequestExecutor.cpp
        oatpp/web/client/RequestExecutor.hpp
        oatpp/web/client/RetryPolicy.cpp
        oatpp/web/client/RetryPolicy.hpp
        oatpp/web/mime/multipart/FileProvider.cpp
        oatpp/web/mime/multipart/FileProvider.hpp
        oatpp/web/mime/multipart/InMemoryDataProvider.cpp
        oatpp/web/mime/multipart/InMemoryDataProvider.hpp
        oatpp/web/mime/multipart/Multipart.cpp
        oatpp/web/mime/multipart/Multipart.hpp
        oatpp/web/mime/multipart/Part.cpp
        oatpp/web/mime/multipart/Part.hpp
        oatpp/web/mime/multipart/PartList.cpp
        oatpp/web/mime/multipart/PartList.hpp
        oatpp/web/mime/multipart/PartReader.cpp
        oatpp/web/mime/multipart/PartReader.hpp
        oatpp/web/mime/multipart/Reader.cpp
        oatpp/web/mime/multipart/Reader.hpp
        oatpp/web/mime/multipart/StatefulParser.cpp
        oatpp/web/mime/multipart/StatefulParser.hpp
        oatpp/web/mime/multipart/TemporaryFileProvider.cpp
        oatpp/web/mime/multipart/TemporaryFileProvider.hpp
        oatpp/web/protocol/CommunicationError.cpp
        oatpp/web/protocol/CommunicationError.hpp
        oatpp/web/protocol/http/Http.cpp
        oatpp/web/protocol/http/Http.hpp
        oatpp/web/protocol/http/encoding/Chunked.cpp
        oatpp/web/protocol/http/encoding/Chunked.hpp
        oatpp/web/protocol/http/encoding/EncoderProvider.hpp
        oatpp/web/protocol/http/encoding/ProviderCollection.cpp
        oatpp/web/protocol/http/encoding/ProviderCollection.hpp
        oatpp/web/protocol/http/incoming/BodyDecoder.cpp
        oatpp/web/protocol/http/incoming/BodyDecoder.hpp
        oatpp/web/protocol/http/incoming/Request.cpp
        oatpp/web/protocol/http/incoming/Request.hpp
        oatpp/web/protocol/http/incoming/RequestHeadersReader.cpp
        oatpp/web/protocol/http/incoming/RequestHeadersReader.hpp
        oatpp/web/protocol/http/incoming/Response.cpp
        oatpp/web/protocol/http/incoming/Response.hpp
        oatpp/web/protocol/http/incoming/ResponseHeadersReader.cpp
        oatpp/web/protocol/http/incoming/ResponseHeadersReader.hpp
        oatpp/web/protocol/http/incoming/SimpleBodyDecoder.cpp
        oatpp/web/protocol/http/incoming/SimpleBodyDecoder.hpp
        oatpp/web/protocol/http/outgoing/Body.cpp
        oatpp/web/protocol/http/outgoing/Body.hpp
        oatpp/web/protocol/http/outgoing/BufferBody.cpp
        oatpp/web/protocol/http/outgoing/BufferBody.hpp
        oatpp/web/protocol/http/outgoing/MultipartBody.cpp
        oatpp/web/protocol/http/outgoing/MultipartBody.hpp
        oatpp/web/protocol/http/outgoing/Request.cpp
        oatpp/web/protocol/http/outgoing/Request.hpp

=== test/CMakeLists.txt ===

add_executable(oatppAllTests
        oatpp/AllTestsMain.cpp
        oatpp/core/async/ConditionVariableTest.cpp
        oatpp/core/async/ConditionVariableTest.hpp
        oatpp/core/async/LockTest.cpp
        oatpp/core/async/LockTest.hpp
        oatpp/core/base/CommandLineArgumentsTest.cpp
        oatpp/core/base/CommandLineArgumentsTest.hpp
        oatpp/core/base/LoggerTest.cpp
        oatpp/core/base/LoggerTest.hpp
        oatpp/core/data/buffer/ProcessorTest.cpp
        oatpp/core/data/buffer/ProcessorTest.hpp
        oatpp/core/data/mapping/TypeResolverTest.cpp
        oatpp/core/data/mapping/TypeResolverTest.hpp
        oatpp/core/data/mapping/type/AnyTest.cpp
        oatpp/core/data/mapping/type/AnyTest.hpp
        oatpp/core/data/mapping/type/EnumTest.cpp
        oatpp/core/data/mapping/type/EnumTest.hpp
        oatpp/core/data/mapping/type/InterpretationTest.cpp
        oatpp/core/data/mapping/type/InterpretationTest.hpp
        oatpp/core/data/mapping/type/ListTest.cpp
        oatpp/core/data/mapping/type/ListTest.hpp
        oatpp/core/data/mapping/type/ObjectTest.cpp
        oatpp/core/data/mapping/type/ObjectTest.hpp
        oatpp/core/data/mapping/type/ObjectWrapperTest.cpp
        oatpp/core/data/mapping/type/ObjectWrapperTest.hpp
        oatpp/core/data/mapping/type/PairListTest.cpp
        oatpp/core/data/mapping/type/PairListTest.hpp
        oatpp/core/data/mapping/type/PrimitiveTest.cpp
        oatpp/core/data/mapping/type/PrimitiveTest.hpp
        oatpp/core/data/mapping/type/StringTest.cpp
        oatpp/core/data/mapping/type/StringTest.hpp
        oatpp/core/data/mapping/type/TypeTest.cpp
        oatpp/core/data/mapping/type/TypeTest.hpp
        oatpp/core/data/mapping/type/UnorderedMapTest.cpp
        oatpp/core/data/mapping/type/UnorderedMapTest.hpp
        oatpp/core/data/mapping/type/UnorderedSetTest.cpp
        oatpp/core/data/mapping/type/UnorderedSetTest.hpp
        oatpp/core/data/mapping/type/VectorTest.cpp
        oatpp/core/data/mapping/type/VectorTest.hpp
        oatpp/core/data/resource/InMemoryDataTest.cpp
        oatpp/core/data/resource/InMemoryDataTest.hpp
        oatpp/core/data/share/LazyStringMapTest.cpp
        oatpp/core/data/share/LazyStringMapTest.hpp
        oatpp/core/data/share/MemoryLabelTest.cpp
        oatpp/core/data/share/MemoryLabelTest.hpp
        oatpp/core/data/share/StringTemplateTest.cpp
        oatpp/core/data/share/StringTemplateTest.hpp
        oatpp/core/data/stream/BufferStreamTest.cpp
        oatpp/core/data/stream/BufferStreamTest.hpp
        oatpp/core/parser/CaretTest.cpp
        oatpp/core/parser/CaretTest.hpp
        oatpp/core/provider/PoolTemplateTest.cpp
        oatpp/core/provider/PoolTemplateTest.hpp
        oatpp/core/provider/PoolTest.cpp
        oatpp/core/provider/PoolTest.hpp
        oatpp/encoding/Base64Test.cpp
        oatpp/encoding/Base64Test.hpp
        oatpp/encoding/UnicodeTest.cpp
        oatpp/encoding/UnicodeTest.hpp
        oatpp/encoding/UrlTest.cpp
        oatpp/encoding/UrlTest.hpp
        oatpp/network/ConnectionPoolTest.cpp
        oatpp/network/ConnectionPoolTest.hpp
        oatpp/network/UrlTest.cpp
        oatpp/network/UrlTest.hpp
        oatpp/network/monitor/ConnectionMonitorTest.cpp
        oatpp/network/monitor/ConnectionMonitorTest.hpp
        oatpp/network/virtual_/InterfaceTest.cpp
        oatpp/network/virtual_/InterfaceTest.hpp
        oatpp/network/virtual_/PipeTest.cpp
        oatpp/network/virtual_/PipeTest.hpp
        oatpp/parser/json/mapping/BooleanTest.cpp
        oatpp/parser/json/mapping/BooleanTest.hpp
        oatpp/parser/json/mapping/DeserializerTest.cpp
        oatpp/parser/json/mapping/DeserializerTest.hpp
        oatpp/parser/json/mapping/DTOMapperPerfTest.cpp
        oatpp/parser/json/mapping/DTOMapperPerfTest.hpp
        oatpp/parser/json/mapping/DTOMapperTest.cpp
        oatpp/parser/json/mapping/DTOMapperTest.hpp
        oatpp/parser/json/mapping/EnumTest.cpp
        oatpp/parser/json/mapping/EnumTest.hpp
        oatpp/parser/json/mapping/UnorderedSetTest.cpp
        oatpp/parser/json/mapping/UnorderedSetTest.hpp
        oatpp/web/ClientRetryTest.cpp
        oatpp/web/ClientRetryTest.hpp
        oatpp/web/FullAsyncClientTest.cpp
        oatpp/web/FullAsyncClientTest.hpp
        oatpp/web/FullAsyncTest.cpp
        oatpp/web/FullAsyncTest.hpp
        oatpp/web/FullTest.cpp
        oatpp/web/FullTest.hpp
        oatpp/web/PipelineAsyncTest.cpp
        oatpp/web/PipelineAsyncTest.hpp
        oatpp/web/PipelineTest.cpp
        oatpp/web/PipelineTest.hpp
        oatpp/web/app/BasicAuthorizationController.hpp
        oatpp/web/app/BearerAuthorizationController.hpp
        oatpp/web/app/Client.hpp
        oatpp/web/app/Controller.hpp
        oatpp/web/app/ControllerAsync.hpp
        oatpp/web/app/ControllerWithErrorHandler.hpp
        oatpp/web/app/ControllerWithInterceptors.hpp
        oatpp/web/app/ControllerWithInterceptorsAsync.hpp
        oatpp/web/app/DTOs.hpp
        oatpp/web/mime/multipart/StatefulParserTest.cpp
        oatpp/web/mime/multipart/StatefulParserTest.hpp
        oatpp/web/protocol/http/encoding/ChunkedTest.cpp
        oatpp/web/protocol/http/encoding/ChunkedTest.hpp
        oatpp/web/server/HttpRouterTest.cpp
        oatpp/web/server/HttpRouterTest.hpp
        oatpp/web/server/ServerStopTest.cpp
        oatpp/web/server/ServerStopTest.hpp
        oatpp/web/server/api/ApiControllerTest.cpp
        oatpp/web/server/api/ApiControllerTest.hpp
        oatpp/web/server/handler/AuthorizationHandlerTest.cpp
        oatpp/web/server/handler/AuthorizationHandlerTest.hpp
)
set_target_source_groups(oatppAllTests STRIP_PREFIX "oatpp")

target_link_libraries(oatppAllTests PRIVATE oatpp PRIVATE oatpp-test)

set_target_properties(oatppAllTests PROPERTIES
    CXX_STANDARD 11
    CXX_EXTENSIONS OFF
    CXX_STANDARD_REQUIRED ON
)
if (MSVC)
    target_compile_options(oatppAllTests PRIVATE /permissive-)
endif()

target_include_directories(oatppAllTests PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})

add_test(oatppAllTests oatppAllTests)

=== PKGBUILD ===
_realname=oatpp
pkgbase=mingw-w64-${_realname}
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgver=1.3.1
pkgrel=1
pkgdesc="Oat++ is an open-source C++ web framework for highly scalable and resource-efficient web applications."
url="https://github.com/oatpp/oatpp"
license=('Apache')
arch=('any')
mingw_arch=('mingw32' 'mingw64' 'ucrt64' 'clang64' 'clangarm64')
makedepends=(
  "${MINGW_PACKAGE_PREFIX}-cc"
  "${MINGW_PACKAGE_PREFIX}-cmake"
  "${MINGW_PACKAGE_PREFIX}-ninja"
)
source=("https://github.com/oatpp/oatpp/archive/refs/tags/${pkgver}.zip")
sha256sums=('d6bf0b4de4af1f0863e7ca946ddb7b824a6e492680c6090cf111902b6809311a')

build() {
  cd "${srcdir}/${_realname}-${pkgver}"
  mkdir -p build
  cd build

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    ${MINGW_PREFIX}/bin/cmake.exe \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
      -DCMAKE_BUILD_TYPE=Release \
      -DOATPP_BUILD_TESTS=OFF \
      ..

  cmake --build .
}

package() {
  cd "$srcdir/${_realname}-${pkgver}/build"
  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake.exe --install .
}
